var PACFile ={
	defaultPref : "extensions.fireproxy.data.default",				
	bakFileName : "fireproxy.bak",
	newFileName : "fireproxy.new",
	PACFileName : "fireproxy.pac",		
//public:
	addSiteToFile:function( aPage)
	{
		var PACFilePath = this.initPath();//---*可储存于pref中，直接获取
		if( this.addItem(PACFilePath, aPage.hostname))
		{//无法处理非常规端口---*
			this.refreshPACFilePref(PACFilePath);
			return true;
		}
		return false;
	},

	addDomainToFile:function( aPage)
	{
		var PACFilePath = this.initPath();//---*可储存于pref中，直接获取
		aURLStr = this.formatHostName( aPage.hostname);	
		if( this.addItem(PACFilePath, aURLStr))
		{//无法处理非常规端口---*
			this.refreshPACFilePref(PACFilePath);
			return true;
		}
		return false;
	},
/*		
	init: function(){
		const defPath = "extensions.fireproxy.data.default";
		const specPath = "extensions.fireproxy.data.folder";
		var path = "";
		
		if( !commTools.PREFS.getBoolPref( defPath))//使用默认文件夹
		{
			path = this.initDefaultPath();
		}else{  //使用用户定义的文件夹
			path = commTools.PREFS.getCharPref( specPath);
		}
		
		this.PACFileDir = path;
		this.bakFileName = path + "\\" + bakFileName;
		this.newFileName = path + "\\" + newFileName;
		this.PACFileName = path + "\\" + PACFileName; 
		return true;
	},
*/					    
////////////////////////////////////////////////////////////////////////////////
// initDefaultPath
//
// Desc: create PAC file's default path relative to chrome:\\fireproxy\data\proxy.pac 
// Parameters: nothing
// Returns: the absolute default path of the folder where PAC exists(Type:String)
////////////////////////////////////////////////////////////////////////////////	
    initDefaultPath: function()
	{
		const id = "fireproxy@zigler.zhang";
		return Components.classes["@mozilla.org/extensions/manager;1"]
              			.getService(Components.interfaces.nsIExtensionManager)
                		.getInstallLocation(id)
                		.getItemLocation(id).path + "\\data";
//        return PACFileDir + "\\data\\" + this.PACFileName; 
	},
		
	togglePath: function()
	{
		const specPathPref = "extensions.fireproxy.data.folder"; 
		var PACFileDirPath = commTools.PREFS.getCharPref( specPathPref);
		if( !commTools.PREFS.getBoolPref( this.defaultPref))
		{
			var defFilePath = this.initDefaultPath() + "\\" + this.PACFileName;
			var defBakFile = this.safePACFileInit( defFilePath);
			var PACFileDir = commTools.initFile( PACFileDirPath);
			defBakFile.copyTo( PACFileDir, PACFile.PACFileName);
		}
		this.refreshPACFilePref( PACFileDirPath + "\\" + this.PACFileName);
	},
	
	initPath: function()
	{
		var PACFileDir;
		if( commTools.PREFS.getBoolPref( this.defaultPref))
		{
			PACFileDir = this.initDefaultPath();
		}
		else{
			const specPathPref = "extensions.fireproxy.data.folder"; 
			PACFileDir = commTools.PREFS.getCharPref( specPathPref);
		}
		return PACFileDir + "\\" + this.PACFileName;

	},
////////////////////////////////////////////////////////////////////////////////
// refreshPACFilePref
//
// Desc: reload the PAC File to Make it valid
// Parameters: Path to locate the PACFile (via arguments[0], type:String)
// Returns: nothing
////////////////////////////////////////////////////////////////////////////////				
	refreshPACFilePref : function(PACFilePath)
    {
    	const prefProxyFlag = "network.proxy.type";
		const prefPAC = "network.proxy.autoconfig_url";
        var fixedURI = commTools.URIFIXUP.createFixupURI(PACFilePath, 0).spec;
        
		if ( commTools.PREFS.getPrefType( prefProxyFlag) == commTools.PREFS.PREF_INT)
		{
  			commTools.PREFS.setIntPref( prefProxyFlag, 2);
  		}
  		
		if ( commTools.PREFS.getPrefType( prefPAC) == commTools.PREFS.PREF_STRING)
  		{
  			commTools.PREFS.setCharPref( prefPAC, fixedURI);
  		}
  		
    	commTools.PACHANDLER.configureFromPAC(fixedURI);//重新载入PAC文件
    },

/*******未实现的功能函数
	recoveryFromBakFile: function( aPACFile)//*----应该将函数挂至FireFox崩溃事件监听处，ver1.3
	{
		const bakFileName = "proxy.bak";
		const PACFileName = "proxy.pac"
		var theBakPACFile = Components.classes["@mozilla.org/file/local;1"]
								.createInstance(Components.interfaces.nsILocalFile);
		var bakFilePath = aPACFile.parent + "\\" + bakFileName;
		theBakPACFile.initWithPath( bakFilePath);
		
		try{
			theBakPACFile.copyTo( aPACFile.parent, PACFileName);
		}catch(ex){
		
		}
	}
*/	

////////////////////////////////////////////////////////////////////////////////
// safePACFileInit
//
// Desc: check the folder of the PAC, if PAC exists, rename it as proxy.bak
//		 otherwise if the proxy.bak & PAC neither exists, the ext is damaged, 
//		 and which cant recovery.
// Parameters: Path to locate the PACFile (via arguments[0], type:String)
// Returns: the Path of the BakFile(type:nsIFile),or, null as ext damaged
//---*** future function: pack a standard PAC file to the jar file, if damaged ,
//---***					decompress it to recovery
//---*** function exp ver: v0.2 publication  
////////////////////////////////////////////////////////////////////////////////	
	safePACFileInit: function( aPathString)
	{

		//初始化PAC文件		
		var thePACFile = commTools.initFile( aPathString);
		if ( thePACFile.exists())
		{
			thePACFile.moveTo( thePACFile.parent, PACFile.bakFileName);
			return thePACFile;
		}else{//由于程序崩溃,未能正确生成pac文件
			var bakFilePath = thePACFile.parent.path + "\\" + this.bakFileName;
			var theBakPACFile = commTools.initFile( bakFilePath);
			if( theBakPACFile.exists())
			{
				return theBakPACFile;
			}else{//*-----可将一标准PAC模版打入jar中,ver0.2正式版
				alert("FireProxy扩展出错，请重新安装");
				return null;
			}
		}	
	},

	

	addItem: function( aPathString, aDomain)
	{
		const insPosFlag = "\\!\\$adominInsPos";
		var theBakPACFile = this.safePACFileInit( aPathString);
//		var wildHostName = this.formatHostName(aDomain);
		
        // open an input stream from file
		var fiStream = Components.classes["@mozilla.org/network/file-input-stream;1"]
						.createInstance(Components.interfaces.nsIFileInputStream);
		fiStream.init(theBakPACFile, 0x01, 0444, 0);
		fiStream.QueryInterface(Components.interfaces.nsILineInputStream);

		// read lines into array
		var line = {}, lines = [], hasmore;
		do {
			hasmore = fiStream.readLine(line);
			
			var testStr = line.value.substr(19);
			var end = testStr.search("\"");
			testStr = testStr.substr(0, end);
//			if( testStr == wildHostName){
			if( testStr == aDomain){
				fiStream.close();
				theBakPACFile.moveTo( theBakPACFile.parent, PACFile.PACFileName);
				//alert("comp");
				return false;
			}
		    lines.push(line.value); 
		} while(hasmore);
		fiStream.close();

		var newFilePath = theBakPACFile.parent.path + "\\" + this.newFileName;
		var theNewPACFile = commTools.initFile( newFilePath);
		
		//open an output stream from file
		var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
                        .createInstance(Components.interfaces.nsIFileOutputStream);

    	//foStream.init(PACFile, 0x04 | 0x08, 0664, 0); // write, create
		// use 0x02 | 0x10 to open file for appending.
		foStream.init(theNewPACFile, 0x02 | 0x08 | 0x20, 0664, 0); // write, create, append
		var cnt = 0;
		do
		{
			foStream.write( lines[cnt],lines[cnt].length);	
			foStream.write( "\n",1);
			if ( lines[cnt].search(insPosFlag) >= 0)
			{
//				var newLine = "		shExpMatch(host,\"" + wildHostName + "\"\)||"
				var newLine = "		shExpMatch(host,\"" + aDomain + "\"\)||"
				foStream.write( newLine, newLine.length);
				foStream.write( "\n",1);
			}
			cnt++;
		} while(cnt < lines.length);
		foStream.close();
		theNewPACFile.moveTo( theBakPACFile.parent, PACFile.PACFileName);
		return true;
	},
	
////////////////////////////////////////////////////////////////////////////////
// formatHostName
//
// Desc: format a Host name to wildcast style.if the host name sections number 
//		 is less than two ,such as "fireinice.cn",or the host name is an IP 
//		 address, the function will do nothing.if style is like 
//		 "www.fireinice.cn",then modify it as "*.fireinice.cn".
// Parameters: a host name (via arguments[0], type:String)
// Returns: a wildcast style host name (type:String)
////////////////////////////////////////////////////////////////////////////////
	formatHostName: function( aURLString)//仅支持标准
	{
		var seg = [];
		commTools.debug("fomate")
		seg = aURLString.split("\.");
		//alert(seg.length);
		if( seg.length < 3)
		{
			return aURLString;
		}
		if( seg[seg.length - 1].match( /\d+/) == null)//非ip地址,改为whildcard形式
		{
			seg[0] = "\*";
		}
		aURLString = seg.join("\.");
		
		return aURLString;
	},
		
	setProxyAdd: function( aPathString, aProxyAdd, aProxyPort)
	{
		const proxyPosFlag = "\\!\\$proxyIPAddPos";
		var theBakPACFile = this.safePACFileInit( aPathString);
		
        // open an input stream from file
		var fiStream = Components.classes["@mozilla.org/network/file-input-stream;1"]
						.createInstance(Components.interfaces.nsIFileInputStream);
		fiStream.init(theBakPACFile, 0x01, 0444, 0);
		fiStream.QueryInterface(Components.interfaces.nsILineInputStream);

		// read lines into array
		var line = {}, lines = [], hasmore;
		do {
			hasmore = fiStream.readLine(line);
		    lines.push(line.value); 
		} while(hasmore);
		fiStream.close();

		var newFilePath = theBakPACFile.parent.path + "\\" + this.newFileName;
		var theNewPACFile = commTools.initFile( newFilePath);
		
		//open an output stream from file
		var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
                        .createInstance(Components.interfaces.nsIFileOutputStream);

    	//foStream.init(PACFile, 0x04 | 0x08, 0664, 0); // write, create
		// use 0x02 | 0x10 to open file for appending.
		foStream.init(theNewPACFile, 0x02 | 0x08 | 0x20, 0664, 0); // write, create, truncate
		var cnt = 0;
		do
		{
			if ( lines[cnt].search(proxyPosFlag) >= 0)
			{
				var newLine = "		return \"PROXY " + aProxyAdd + ":" + aProxyPort + "\";		\/\/\!\$proxyIPAddPos"
				foStream.write( newLine, newLine.length);
				foStream.write( "\n",1);
			}else{
				foStream.write( lines[cnt],lines[cnt].length);	
				foStream.write( "\n",1);
			}
			cnt++;
		} while(cnt < lines.length);
		foStream.close();
		theNewPACFile.moveTo( theBakPACFile.parent, PACFile.PACFileName);
		return true;
	},
	
	getProxyAdd: function( aPathString)
	{
		const proxyPosFlag = "\\!\\$proxyIPAddPos";
		var thePACFile = commTools.initFile( aPathString);
		if ( !thePACFile.exists())
		{
			var bakFilePath = thePACFile.parent.path + "\\" + this.bakFileName;
			var theBakPACFile = commTools.initFile( bakFilePath);
			if( theBakPACFile.exists())
			{
				theBakPACFile.copyTo( theBakPACFile.parent, PACFile.PACFileName);
				thePACFile = theBakPACFile;
			}else{//*-----可将一标准PAC模版打入jar中,ver0.2正式版
				alert("FireProxy扩展出错，请重新安装");
				return null;
			}
		}	
        // open an input stream from file
		var fiStream = Components.classes["@mozilla.org/network/file-input-stream;1"]
						.createInstance(Components.interfaces.nsIFileInputStream);
		fiStream.init(thePACFile, 0x01, 0444, 0);
		fiStream.QueryInterface(Components.interfaces.nsILineInputStream);
		// read lines into array
		var line = {}, hasmore, testStr;
		do {
			hasmore = fiStream.readLine(line);
			testStr = line.value;
		    if( testStr.search( proxyPosFlag) >= 0){
		    	testStr= testStr.substr(16);
		 		var end = testStr.search("\"");
		 		fiStream.close();
				return testStr.substr(0, end);
		    }
		} while(hasmore);
		fiStream.close();
		alert("FireProxy数据文件出错，请重新安装");
		return null;
	}
	
}